/*------------------------------------------------------------*/
/* sample.c : ץ롦ɥ饤лѥץ                */
/*                                                            */
/*      1998.11.16  original coding  by K.Yamaoka             */
/*------------------------------------------------------------*/
#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include "ttdrv.h"

/*SIGINTϥɥ*/
static void sigint_catch(int num)
{
   fprintf(stderr,"interrupt!!\n");
   fflush(stderr);
}

/*USAGE*/
static void usage()
{
    fprintf(stderr,"sample [devicefile] [speed]");
    exit(1);
}

/* ̿®ʸ ioctl ͤѴ */
static int get_speed(const char* str)
{
    switch(atoi(str)) {
    case 75:    return TTDRV_75;
    case 150:   return TTDRV_150;
    case 300:   return TTDRV_300;
    case 600:   return TTDRV_600;
    case 1200:  return TTDRV_1200;
    case 2400:  return TTDRV_2400;
    case 4800:  return TTDRV_4800;
    case 9600:  return TTDRV_9600;
    case 19200: return TTDRV_19200;
    case 38400: return TTDRV_38400;
    case 57600: return TTDRV_57600;
    case 115200:return TTDRV_115200;
    }
    return -1;
}

/*ᥤؿ*/
main(int argc, char**argv)
{
    int fd, pid, len;
    char buf[1];
    struct termios tattr;
    int   speed   = TTDRV_9600;
    char* devfile = "/dev/ttdrv1";

    /* ǥХե̾ */
    if (argc > 1) devfile = argv[1];
    /* ̿®ٻ */
    if (argc > 2) {
        speed = get_speed(argv[2]);
        if (speed < 0) usage();
    }
    /* ץɥ饤Ф open  */
    if ((fd = open(devfile, O_RDWR)) == -1) {
        fprintf(stderr,"%s open error.\n",devfile);
        exit(1);
    }
    /* ̿® */
    if (ioctl(fd, TTDRV_SETSPEED, &speed) == -1) {
        perror("ioctl");
        exit(1);
    }

    /* ɸϤ飱ʸñ̤˼뤿 */
    tcgetattr(0,&tattr);
    tattr.c_lflag &= ~(ICANON|ECHO);
    tcsetattr(0,TCSANOW,&tattr);

    /*SIGINTϥɥ*/
    signal(SIGINT,sigint_catch);
    if (pid = fork()) {
        /*--- ɸϤ /dev/ttdrv? ؽϤ ---*/
        while(1) {
            len = read(0,buf,1);
            if (len == -1) {
                break; /*ERROR*/
            }
            if (read(0,buf,1) != 1) /* ɸϤ飱Хȼ */
                break;
            if (buf[0] == '\n') 
                len = write(fd,"\r\n",2); /* '\n'  '\r\n' ֤ */
            else
                len = write(fd, buf, 1); /* /dev/ttdrv? 1ХȽ */
            if (len == -1) {
                perror("write");
                kill(SIGKILL,pid);
                break;
            }
        }
        close(fd);
        tcgetattr(0,&tattr);
        tattr.c_lflag |= (ICANON|ECHO);
        tcsetattr(0,TCSANOW,&tattr);
    } else {
        /*---- ǥХϥǡɸϤؽϤ ---*/
        while(1) {
            /* /dev/ttdrv? Хȼ */
            len = read(fd,buf,1);
            if (len == -1) {
                /* ʥȯˤϥ顼(errono = EINTR)Ȥʤ */
                perror("read");
                break;
            }
            /*  ɸϤؽ */
            if (buf[0] == '\r')
                write(1,"\r\n",2); /* "\r" ==> "\r\n" */
            else
                write(1,buf,1); /* ɸϤأХȽ */
        }
    }
}
