/*------------------------------------------------------------*/
/* ttdrv.c : LINUX ץ롦ɥ饤(ꥢ̿)           */
/*      1998.11.16  original coding  by K.Yamaoka             */
/*      2000.04.30  ͥ룲б                      */
/*------------------------------------------------------------*/
#include <linux/module.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/signal.h>
#include <linux/sched.h>
#include <linux/config.h>
#include <linux/major.h>
#include <linux/poll.h>
#include "ttdrv.h"

#include <asm/io.h>
#include <asm/system.h>
#include <asm/segment.h>
#include <asm/bitops.h>

#define DBG(x)

/*------ COM IOݡȥɥ쥹 offset  -------*/
#define RS_DATA  0
#define RS_IER   1
#define RS_IIR   2
#define RS_LCR   3
#define RS_MCR   4
#define RS_LSR   5
#define RS_MSR   6
#define RS_SCR   7

#ifndef TTDRV_MAJOR
#define TTDRV_MAJOR  99   /* ץɥ饤С᥸㡼ֹ */
#endif

#define TTDRV_MAX_MINOR 1                   /*ޥʡֹ*/
#define TTDRV_NPORT     (TTDRV_MAX_MINOR+1) /*ݡȿ        */

/*=================================================*/
/* ɥ饤Хǡѹ¤                      */
/*=================================================*/
typedef struct {
    /* ǡХåե */
    unsigned char rbuf[256];  /* Хåե       */
    int           rdpos;      /* ǡ¸ */
    int           rpos;       /* ɤ߽Ф   */
    int           rcnt;       /* ǼХȿ   */
    struct wait_queue* read_waitq;/*ɤ߹Ʊѥ塼*/
    /* ǡХåե */
    unsigned char wbuf[256];  /* Хåե       */
    int           wdpos;      /* ǡ¸ */
    int           wpos;       /* ɤ߽Ф   */
    int           wcnt;       /* ǼХȿ   */
    struct wait_queue* write_waitq;/*񤭹Ʊѥ塼*/
    unsigned long base;       /* I/Oݡȥ١ɥ쥹 */
    int           irq;        /* ֹ   */
    int           iSpeed;     /* ̿®       */
    int           openCnt;    /* Open       */
} ttdrv_dev_t;
/* ǥХơ֥ */
static ttdrv_dev_t ttdrv[TTDRV_NPORT] = {
 {{0},0,0,0,NULL,{0},0,0,0,NULL,0x3f8,4,TTDRV_9600,0},/*COM1:I/O=3F8-3FF:IRQ=4*/
 {{0},0,0,0,NULL,{0},0,0,0,NULL,0x2f8,3,TTDRV_9600,0},/*COM2:I/O=2F8-2FF:IRQ=3*/
};

/*===========================================*/
/* ꥢ̿Ѷ̴ؿ                    */
/*===========================================*/
/*----------------------------------------*/
/* ǡƥХåե˳Ǽ */
/*----------------------------------------*/
static void ReadData(ttdrv_dev_t* dev)
{
    unsigned long base=dev->base;
    /* ǡмХåե˥ԡ */
    while(inb(base+RS_LSR) & 0x01) {
        int rdpos = dev->rdpos;
        dev->rbuf[rdpos] = (unsigned char)(inb(base+RS_DATA)&0xff);
        dev->rdpos++;
        dev->rcnt++;
        if (dev->rdpos >= 256)
            dev->rdpos = 0;
        if (dev->rcnt > 256) {
            dev->rcnt = 256;
            dev->rpos = dev->rdpos;
        }
    }
}

/*-----------------------------------------*/
/* ХåեǥХؤΥǡ  */
/*-----------------------------------------*/
static void WriteData(ttdrv_dev_t* dev)
{
    int wpos;
    unsigned char c;
    unsigned long base;
    base = dev->base;
    /*---- ǥХBUSYǡޤǥ롼 ----*/
    while(inb(base+RS_LSR) & 0x20 && dev->wcnt > 0) {
        /*ǥХؤΥǡ*/
        wpos = dev->wpos;
        c = dev->wbuf[wpos];
        outb(c, base+RS_DATA);
        /*Хåեǡɤ߽Фֹ*/
        dev->wpos++;
        if (dev->wpos >= 256)
            dev->wpos = 0;
        dev->wcnt--;
    }
    if (dev->wcnt > 0) {
       /*ǥХBUSY(ХåեFULL)Ǥʤ*/
       /*Хåեˤʤäߤȯ  */
       outb(0x03, base+RS_IER);
    } else {
       /*ǡѤ*/
       /*Хåեߤꤷʤ*/
       outb(0x01, base+RS_IER);
       dev->wpos  = 0;
       dev->wdpos = 0;
       dev->wcnt  = 0;
    }
}

/*=========================================*/
/* ߽ؿ                        */
/*=========================================*/
static void ttdrv_interrupt(int irq, void *dev_id, struct pt_regs * regs)
{
    unsigned int iir;
    unsigned long base;
    int minor,res;

    /* ǥХ */
    ttdrv_dev_t* dev = dev_id;

    base = dev->base;

    iir = inb(base+RS_IIR); /* װ */
    res = (iir >> 1)&3;
    switch(res) {
    case 0: (void)inb(base+RS_MSR); break;
    case 3: (void)inb(base+RS_LSR); break;
    case 2:/*װ:ǡȯ*/
        /* ǡǡɤߤȤ */
        ReadData(dev);
        if (dev->rcnt > 0) {
            /*--------  READ̲ץ򵯤 -----------*/
            wake_up_interruptible(&dev->read_waitq);
        }
        break;
    case 1:/*װ:ǥХХåե*/
        /* ̤ǡ*/
        WriteData(dev);
        if (dev->wcnt == 0) {/*ǡλ*/
            /*--------  WRITE̲ץ򵯤 -----------*/
            wake_up_interruptible(&dev->write_waitq);
        }
        break;
    }
}

/*=============================================================*/
/* ɥ饤Хȥؿ                                        */
/*=============================================================*/
/*---------------------------*/
/* OPEN ؿ                 */
/*---------------------------*/
static int ttdrv_open(struct inode * inode, struct file * filp)
{
    int retval;
    int minor;
    int base;
    DBG(printk(KERN_INFO "ttdrv_open\n");)

    minor = MINOR(inode->i_rdev); /*ޥʡֹ inode */
    if (minor < 0 || minor > TTDRV_MAX_MINOR) {
        return -ENOENT;/*ERROR:ޥʡֹ椬*/
    }
    if (ttdrv[minor].openCnt > 0) {
        /* ˥ץ󤷤Ƥ */
        return -EALREADY;/*ERROR:ʣץػ*/
    }
    ttdrv[minor].openCnt++; /*OPEN*/

    base = ttdrv[minor].base;
    /* ߶ػ */
    cli();
    outb(0, base+RS_IER);

    /* 9600bps() */
    outb(0x80, base+RS_LCR);
    outb(12,   base+RS_DATA);
    outb(0,    base+RS_DATA+1);
    ttdrv[minor].iSpeed = TTDRV_9600;  /* ̿®ٽ */ 

    /* 8bit, ѥƥʤ */
    outb(0x3, base+RS_LCR);   /*8bit*/

    /*  COM1=4, COM2=3*/
    retval = request_irq(ttdrv[minor].irq, ttdrv_interrupt,
                         SA_INTERRUPT, "ttdrv", &ttdrv[minor]);

    /* DTR,DSR ON, ߵ */
    outb(0x0b, base+RS_MCR);

    /* ߵ */
    outb(0x01, base+RS_IER);

    (void)inb(base+RS_LSR);
    (void)inb(base+RS_DATA);
    (void)inb(base+RS_IIR);
    (void)inb(base+RS_MSR);
    sti();

    /* ǡХåե */
    ttdrv[minor].rdpos = 0;
    ttdrv[minor].rpos  = 0;
    ttdrv[minor].rcnt  = 0;
    /* ǡХåե */
    ttdrv[minor].wdpos = 0;
    ttdrv[minor].wpos  = 0;
    ttdrv[minor].wcnt  = 0;

    /* file ¤Υץ饤١ȥǡȤƥɥ饤о¸ */
    filp->private_data = &ttdrv[minor];
    return 0;
}

/*----------------------------*/
/* CLOSE ؿ                 */
/*----------------------------*/
static int ttdrv_close(struct inode * inode, struct file * filp)
{
    int minor, base;
    DBG(printk(KERN_INFO "ttdrv_close\n");)

    ttdrv_dev_t* dev = filp->private_data;
    base = dev->base;
    dev->openCnt--;
    if (dev->openCnt < 0) 
        dev->openCnt = 0;
    cli();
    outb(0, base+RS_IER); /* ߶ػ */
    outb(0, base+RS_MCR); /* DTR,DSR OFF */
    free_irq(dev->irq, NULL); /* IRQ4  */
    sti();
    return 0;
}

/*---------------------------*/
/* READ ؿ                 */
/*---------------------------*/
static int ttdrv_read(struct file * filp, char * buf, size_t count, loff_t* ppos)
{
    int n, rpos, err;
    unsigned char d;

    ttdrv_dev_t* dev = filp->private_data;

    err = verify_area(VERIFY_WRITE, (void*)buf, count);
    if (err) return err;/* arg  */

    cli();
    /* ǡɤߤȤ */
    ReadData(dev);
    sti();

    if (dev->rcnt == 0) { /* ǡʤ */
        /*--------- ǡȯޤǥץ̲ ---------*/
        interruptible_sleep_on(&dev->read_waitq);
        if (signal_pending(current)) {
            /*ʥΤǥ顼֤ */
            return -ERESTARTSYS;
        }
    }

    /*--- ǡХåեץ˥ǡ֤ ---*/
    for(n = 0; n < count; n++) {
        if (dev->rcnt == 0) {
            dev->rpos  = 0;
            dev->rdpos = 0;
            break;/*ǡץ˥ԡλ*/
        }

        /*ХåեΥǡФ*/
        cli();
        rpos = dev->rpos;
        d = dev->rbuf[rpos];
        dev->rcnt--;
        dev->rpos++;
        if (dev->rpos >= 256) {
            dev->rpos = 0;
        }
        sti();
        put_user(d,buf+n); /* 桼ץ˼ǡʣ */
    }
    return n; /* ǡХȿ֤ */
}

/*----------------------------*/
/* WRITE ؿ                 */
/*----------------------------*/
static int ttdrv_write(struct file * filp, const char * buf, size_t count, loff_t* ppos)
{
    int n, base, wdpos, err;
    unsigned char c;

    ttdrv_dev_t* dev = filp->private_data;

    base  = dev->base;

    err = verify_area(VERIFY_READ, (void*)buf, count);
    if (err) return err;/* buf  */
    for(n = 0; ; n++) {
        if(dev->wcnt < 256 && n < count) {
             cli();
             /* 桼ץϥǡ*/
             get_user(c, buf+n);
             /* Хåե˥ԡ */
             wdpos = dev->wdpos;
             dev->wbuf[wdpos] = c;
             dev->wdpos++;
             if (dev->wdpos >= 256)
                 dev->wdpos = 0;
             dev->wcnt++;
             sti();
        } else {
             cli();
             /*ХåեǥХؤΥǡ*/
             WriteData(dev);
             sti();
             if (dev->wcnt <= 0) {
                 break;/*ǡλ*/
             } else {
                 /* ǥХBUSYǤʤǡ */
                 /* BUSYԤǥץ̲             */
                 interruptible_sleep_on(&dev->write_waitq);
                 if (signal_pending(current)) {
                     /* ʥΤǥ顼֤ */
                     return -ERESTARTSYS;
                 }
             }
        }
    }
    DBG(printk(KERN_INFO "write_ttdrv: n=%d\n",n);)
    return count;
}

/*----------------------------*/
/* IOCTL ؿ                 */
/*----------------------------*/
static int ttdrv_ioctl(struct inode *inode, struct file *filp,
                       unsigned int request, unsigned long arg)
{
    int err, s;
    unsigned long base;
    /* ̿®ʬ */
    static unsigned short speed[] = {
        1536, 768, 384, 192, 96, 48, 24, 12, 6, 3, 2, 1
    };
    ttdrv_dev_t* dev = filp->private_data;
    base  = dev->base;

    switch(request) {
    case TTDRV_GETSPEED:
        /*  arg Υɥ쥹å */
        err = verify_area(VERIFY_WRITE, (void*)arg, sizeof(int));
        if (err) /* arg  */
            return err;
        put_user(dev->iSpeed, (int*)arg);
        break;
    case TTDRV_SETSPEED:
        /*  arg Υɥ쥹å */
        err = verify_area(VERIFY_READ, (void*)arg, sizeof(int));
        if (err) /* arg  */
            return err;
        /* 桼֤饳ԡ */
        get_user(s, (int*)arg);
        if (s < TTDRV_75 && s > TTDRV_115200)
            return -EINVAL; /* arg  */

        /* ̿® */
        cli();
        outb(0x80, base+RS_LCR);/*®*/ 
        outb(speed[s]&0xff,       base+RS_DATA);   
        outb((speed[s]>>8)&0xff,  base+RS_DATA+1);
        outb(0x3, base+RS_LCR); /* 8bit, ѥƥʤ */
        sti();

        dev->iSpeed = s;
        break;
    default:
        return -EINVAL; /*  request  */
    }
    return 0;
}

/*===========================================================================*/
/* ǥХɥ饤Ͽ                                                  */
/*===========================================================================*/
/*---------------------------------*/
/* եؿ            */
/*---------------------------------*/
static struct file_operations ttdrv_fops = {
    NULL,           /* lseek   */
    ttdrv_read,     /* read    */
    ttdrv_write,    /* write   */
    NULL,           /* readdir */
    NULL,           /* poll    */
    ttdrv_ioctl,    /* ioctl   */
    NULL,           /* memmap  */
    ttdrv_open,     /* open    */
    NULL,           /* flush   */
    ttdrv_close,    /* close   */
    NULL,           /* fsync   */
    NULL,           /* fasync  */
};

/*-------------------------------------------*/
/* ǥХɥ饤Ͽ                  */
/*-------------------------------------------*/
int ttdrv_init(void)
{
    int iRet;
    /* 饯ǥХɥ饤Ͽ */
    iRet = register_chrdev(TTDRV_MAJOR,"ttdrv",&ttdrv_fops);
    if (iRet < 0) {
        printk(KERN_NOTICE "ERR:ttdrv:init_modlue: register_chardev ret=%d\n",
               iRet);
        return iRet;
    }
    /*ɥ饤ФѤI/OݡȤ*/
    request_region(ttdrv[0].base, 8, "ttdrv1");/*COM1: 3F8-3FF*/
    request_region(ttdrv[1].base, 8, "ttdrv2");/*COM2: 2F8-2FF*/
    return 0;
}


/*===========================================*/
/* ⥸塼뵡ǽݡ                    */
/*===========================================*/
#ifdef MODULE
/*-------------------------------------------*/
/* ǥХɥ饤Ͽ                  */
/*   insmod ޥɤˤʥߥå */
/*-------------------------------------------*/
int init_module(void)
{
    return ttdrv_init();
}

/*------------------------------------*/
/* ǥХɥ饤к           */
/*   rmmod ޥɤˤɥ饤к */
/*------------------------------------*/
void cleanup_module(void)
{
    /*I/OݡȤ*/
    release_region(ttdrv[0].base, 8, "ttdrv1");
    release_region(ttdrv[1].base, 8, "ttdrv2");
    /* 饯ǥХɥ饤к */
    unregister_chrdev(TTDRV_MAJOR,"ttdrv");
}
#endif
